<cfcomponent output="false">

	<!--- preHandler --->
	<cffunction name="preHandler" returntype="void" output="false">
		<cfargument name="event">
		<cfscript>	
			log.debug("Incoming request for route: #event.getCurrentRoute()#");
			event.setValue("results", prepareResults());
		</cfscript>
	</cffunction>
	
	<!--- postHandler --->
	<cffunction name="postHandler" returntype="void" output="false">
		<cfargument name="event">
		<cfscript>	
			event.renderData(data=event.getValue("results"),type="json",jsonAsText=true);
		</cfscript>
	</cffunction>
	
	<!--- prepareReturn --->
	<cffunction name="prepareResults" output="false" access="private" returntype="struct" hint="Prepare a new return structure">
		<cfscript>
			var results = {
				error 		= false,
				messages 	= "",
				data 		= ""
			};
			
			return results;
		</cfscript>
	</cffunction>	
	
	<!--- setHeader --->
	<cffunction name="setHeader" output="false" access="private" returntype="void" hint="Set an HTTP Header">
		<cfargument name="statusCode" type="string" required="true" hint="The status code"/>
		<cfargument name="statusText" type="string" required="false" default="" hint="The status text"/>
	
		<cfheader statuscode="#arguments.statuscode#" statusText="#statusText#">
	</cffunction>

	<!--- onError --->
	<cffunction name="onError" returntype="void" output="false">
		<cfargument name="event">
		<cfargument name="faultAction"/>
		<cfargument name="exception"/>		
		<cfscript>	
			var rc		= event.getCollection();
			
			// Setup the results
			rc.results.error	 = true;
			rc.results.messages = "The action:#faultaction# failed: #exception.detail# #exception.message#";
			
			// Log it
			log.error(rc.results.messages, exception);
			
			// Headers
			setHeader(500,rc.results.messages);
			
			postHandler(event);
		</cfscript>
	</cffunction>
	
</cfcomponent>