<cfcomponent output="false" hint="Security for REST service">
<cfscript>	
	/** 
	* Security interceptor for the demo application
	*/
	function preProcess(event,interceptData){
		var rc = event.getCollection();
		
		// Param APIKey
		event.paramValue("APIKey","");
		
		// Check if security is enabled
		if(NOT getSetting("APISecurity") OR reFindNocase("^general\.index",event.getCurrentRoute()) ){
			return;
		}
		
		// Get API Key from possible sourcces, header takes precedence
		if( len(event.getHTTPHeader("APIKey","")) ){ 
			rc.APIKey = event.getHTTPHeader("APIKey");
		}
		
		// Validate APIKey
		if( rc.APIKey NEQ getSetting("APIKey") ){
			log.info("Invalid APIKey detected: #rc.APIKey# from #cgi.REMOTE_ADDR#, route: #event.getCurrentRoute()#");
			event.overrideEvent("General.invalidAPIKey");
		}	
	}
	
	/**
	* Intercept exceptions
	*/
	function onException(event,interceptData){
		var exception = interceptData.exception;
		
		// Check if invalid event?
		if( exception.type eq "HandlerService.EventHandlerNotRegisteredException"){
			controller.getRequestService().getFlashScope().put("invalidEvent", event.getCurrentEvent());
			setnextEvent('General.invalidEvent');
		}
	}
</cfscript>
</cfcomponent>