//
//  ColdFusionDemoViewController.m
//  ColdFusionDemo
//
//  Created by Josh Highland on 7/6/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "ColdFusionDemoViewController.h"

//import classes for ASIHTTPRequest
#import "ASIHTTPRequest.h"
#import "ASIFormDataRequest.h"
#import "ASINetworkQueue.h"
#import "Reachability.h"

//import class for TouchJSON 
#import "CJSONDeserializer.h"

//constant for the url to the api
NSString *apiBaseURL = @"http://demos.coldbox.org/cfunited2010/iPhoneDemo/index.cfm";
NSString *apiKey = @"BD7ADC6749";


@implementation ColdFusionDemoViewController

//create the getters and setters for the items hat will be changing
@synthesize nameTextField;
@synthesize postButton;
@synthesize getButton;			
@synthesize resultsLabel;
@synthesize rawResultsTextView;

/****************************************************/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
    [super viewDidLoad];	
}

/****************************************************/

//hide the keyboard when the user touches away from the text field
- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event 
{
	[nameTextField resignFirstResponder];
}

/****************************************************/

//hide the keyboard when the done button is pressed
- (BOOL)textFieldShouldReturn:(UITextField *)textField 
{
	[textField resignFirstResponder];	
	return NO;
}

/****************************************************/

//functon that gets called when we press the post button
- (IBAction) sendViaPOST
{
	//hide the keyboard if its showing
	[nameTextField resignFirstResponder];
	
	//get the a using POST 
	NSString *response = [self doPOST];
	
	//process the responce, display it 
	[self processResponce:response];
}

/****************************************************/

//functon that gets called when we press the get button
- (IBAction) sendViaGET
{
	//hide the keyboard if its showing
	[nameTextField resignFirstResponder];
	
	//get the a using POST 
	NSString *response = [self doGET];
	
	//process the responce, display it 
	[self processResponce:response];
}

/****************************************************/

//do the POST 
- (NSString *) doPOST
{
		
	//build the url string, to post data to
	NSString *apiURLString = [NSString stringWithFormat:@"%@/API/echo", apiBaseURL];
	
	//build a URL object
	NSURL *apiURL = [NSURL URLWithString:apiURLString];
	
	//build the POST request
	ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:apiURL];
	[request addRequestHeader:@"apikey" value:apiKey];
	[request setPostValue:nameTextField.text forKey:@"name"];
		
	//send a synchronous reqest to the url
	[request startSynchronous];
	
	NSError *request_error = [request error];
	
	//we have an error
	if (request_error) 
	{		
		return @"error making request";
	}
	
	else 
	{
		//we got a response back from the server
		NSString *response = [request responseString];

		return response;
	}

}


/****************************************************/

- (NSString *)doGET
{

	NSString *apiURLString = [NSString stringWithFormat:@"%@/API/echo/name/%@", apiBaseURL, nameTextField.text];
	
	NSLog(@"%@", apiURLString);
	
	NSURL *apiURL = [NSURL URLWithString:apiURLString];
	
	//build the GET request
	ASIHTTPRequest *request = [ASIHTTPRequest requestWithURL:apiURL];
	[request addRequestHeader:@"apikey" value:apiKey];
	
	//send a synchronous reqest to the url
	[request startSynchronous];
	
	NSError *request_error = [request error];
	
	//we have an error
	if (request_error) 
	{		
		return @"error making request";
	}
	
	else 
	{
		//we got a response back from the server
		NSString *response = [request responseString];

		return response;
	}

	
}

/****************************************************/

-(void) processResponce: (NSString *) response
{
	NSDictionary *dataFromJSON = [[NSDictionary alloc] init];
	dataFromJSON = [self parseJSONString:response];
			
	resultsLabel.text = [dataFromJSON objectForKey:@"data"];
	rawResultsTextView.text = response;	
}

/****************************************************/

- (NSDictionary *)parseJSONString: (NSString *) theJSONString
{
	
	NSData *JSONData = [theJSONString dataUsingEncoding:NSUTF8StringEncoding];
	
	NSError *error = nil;
	NSDictionary *dictionary = [[CJSONDeserializer deserializer] deserializeAsDictionary:JSONData error:&error];
	
	return dictionary;
}

/****************************************************/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
